﻿using System;
using System.Collections.Generic;
using System.ComponentModel.Composition;
using System.ComponentModel.Composition.Hosting;
using System.IO;
using System.Reflection;
using System.Web;
using Wisej.Web;
using YobsManager.Dal.Mongo;
using YobsManager.Dal.Poco;
using YobsManager.Kernel;
using YobsManager.Screens;

namespace YobsManager
{
    public partial class MainDesktop : Desktop
    {
        [ImportMany(typeof(IYobsManagerModule))]
        private List<IYobsManagerModule> Modules { get; set; }
        private User mUser = null;
        public event LogOffDelegate LogOff;
        private MenuData mData = new MenuData(HttpContext.Current);
        public MainDesktop()
        {

            Initialize();
      //      lblVersion.Text = string.Format(lblVersion.Text, Application.ProductVersion);
    //       this.lblVersion.Anchor = ((Wisej.Web.AnchorStyles)((Wisej.Web.AnchorStyles.Bottom | Wisej.Web.AnchorStyles.Right)));
         
        }
        void LoadDesktop(IYobsManagerModule module)
        {
            module.Init(mUser);
            Application.Desktop = module as Desktop;
        }
        private void Initialize()
        {
            InitializeComponent();
      //      this.pictLogo.Anchor = ((Wisej.Web.AnchorStyles)((Wisej.Web.AnchorStyles.Bottom | Wisej.Web.AnchorStyles.Right)));
        //    this.modules1.Anchor = ((Wisej.Web.AnchorStyles)((Wisej.Web.AnchorStyles.Bottom | Wisej.Web.AnchorStyles.Left)));
            if (Application.Session["User"] != null)
            {
                mUser = Application.Session["User"] as User;
       //         lblName.Text = $"{mUser.FirstName} {mUser.Surname}";
                AlertBox.Show($"Welcome back {mUser.FirstName}!", MessageBoxIcon.Information);
            }
          

         //   LoadMef();
            this.modules1.LoadDesktop += LoadDesktop;
            this.modules1.Init(Modules);

        }
        private CompositionContainer _container = null;
        private void LoadMef()
        {
            var catalog = new AggregateCatalog();
            catalog.Catalogs.Add(new AssemblyCatalog(Assembly.GetExecutingAssembly()));
            catalog.Catalogs.Add(new DirectoryCatalog(Path.Combine(Application.StartupPath, "Modules")));
            _container = new CompositionContainer(catalog);

            try
            {
                _container.ComposeParts(this);
            }
            catch (CompositionException exc)
            {

                MessageBox.Show(exc.Message);
            }
            catch (Exception exc)
            {
                MessageBox.Show(exc.Message);
            }
        }
   

        private void SendNotification(string Message, MessageBoxIcon alertType)
        {
            AlertBox.Show(Message, alertType);
        }

        private void panel1_PanelCollapsed(object sender, EventArgs e)
        {

        }

   
    }
}
